// Copyright 2020 RnD Center "ELVEES", JSC

#pragma once
#include <fcntl.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <stdexcept>
#include <unistd.h>

#include <linux/elcore50.h>

class DmaBuf {
 public:
    DmaBuf(size_t size);
    DmaBuf(const DmaBuf &dmabuf) = delete;
    ~DmaBuf();

    int get_fd() { return m_buf.dmabuf_fd; }

    size_t m_size;
    void *m_data;
 private:
    void open_device();

    int m_elcore_fd;
    struct elcore50_buf m_buf;
};
